import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:checksum_plugin/checksum_plugin.dart';

void main() {
  const MethodChannel channel = MethodChannel('checksum_plugin');

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return '42';
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('getPlatformVersion', () async {
    expect(await ChecksumPlugin.getChecksumWithPath('/var/mobile/Containers/Data/Application/DB160087-739F-4C5E-8DE8-402D796557F7/Documents/Download/IMG_0295.JPG'), 'GB5/4IQhXtnLZV0qg7bfBA==');
  });
}
